package com.sun.jndi.dns;

import java.util.Hashtable;

class NameNode
{
    private String label;
    private Hashtable<String, NameNode> children;
    private boolean isZoneCut;
    private int depth;
    
    NameNode(String label) {
        this.children = null;
        this.isZoneCut = false;
        this.depth = 0;
        this.label = label;
    }
    
    protected NameNode newNameNode(String s) {
        return new NameNode(s);
    }
    
    String getLabel() {
        return this.label;
    }
    
    int depth() {
        return this.depth;
    }
    
    boolean isZoneCut() {
        return this.isZoneCut;
    }
    
    void setZoneCut(boolean isZoneCut) {
        this.isZoneCut = isZoneCut;
    }
    
    Hashtable<String, NameNode> getChildren() {
        return this.children;
    }
    
    NameNode get(String key) {
        return (this.children != null) ? ((NameNode)this.children.get(key)) : null;
    }
    
    NameNode get(DnsName dnsName, int n) {
        for (; n < dnsName.size() && this != null; ++n) {
            this = this.get(dnsName.getKey(n));
        }
        return this;
    }
    
    NameNode add(DnsName dnsName, int i) {
        String value;
        String key;
        NameNode nameNode;
        for (; i < dnsName.size(); this = nameNode, ++i) {
            value = dnsName.get(i);
            key = dnsName.getKey(i);
            nameNode = null;
            if (this.children == null) {
                this.children = new Hashtable();
            }
            else {
                nameNode = (NameNode)this.children.get(key);
            }
            if (nameNode == null) {
                nameNode = this.newNameNode(value);
                nameNode.depth = this.depth + 1;
                this.children.put(key, nameNode);
            }
        }
        return this;
    }
}
